#include <stdio.h>
#include <stdlib.h>
#include <pci/pci.h>
#include <sys/types.h>
#define PCI_CMD 4
#define PCI_BME 4
#define ME_DEVICE 3
#define IDER_FUNC 2
int main()
{

        struct pci_access *pci;
        struct pci_dev *dev;

        u16 cmd;

        if (iopl(3) < 0)
                perror("iopl(3)");

        pci = pci_alloc();
        pci_init(pci);
        dev = pci_get_dev(pci, 0, 0, ME_DEVICE, IDER_FUNC);
        if (!dev) {
                perror("pci_get_dev()");
		exit(1);
	}
        pci_fill_info(dev, PCI_FILL_IDENT);

        printf("0x%x 0x%x\n", (int) (dev->vendor_id),
               (int) (dev->device_id));
        cmd = pci_read_word(dev, PCI_CMD);
        pci_write_word(dev, PCI_CMD, cmd | PCI_BME);
        cmd = pci_read_word(dev, PCI_CMD);
        if (cmd & PCI_BME)
                printf("Set the IDER device BME bit ok.\n");
        else
                printf("Error, cmd=0x%x\n", (unsigned int) cmd);

        pci_cleanup(pci);
        return 0;
}

